Use a Value Formatter to provide text formatting of values.
In the example below:
- Column
Raw Valuedisplays the value of theafield of the row data. - Column
Currency Amount (£)uses acurrencyFormatterto display the value as a currency. - Column
Bracketed Valueuses abracketsFormatterto display the value inside brackets.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([CellStyleModule, ClientSideRowModelModule]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ headerName: "Raw Value", field: "a" },
{
headerName: "Currency Amount (£)",
field: "a",
valueFormatter: currencyFormatter,
},
{
headerName: "Bracketed Value",
field: "a",
valueFormatter: bracketsFormatter,
},
];
defaultColDef: ColDef = {
flex: 1,
cellClass: "number-cell",
};
rowData: any[] | null = createRowData();
}
function bracketsFormatter(params: ValueFormatterParams) {
return "(" + params.value + ")";
}
function currencyFormatter(params: ValueFormatterParams) {
return "£" + formatNumber(params.value);
}
function formatNumber(number: number) {
return Math.floor(number).toLocaleString();
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(((i + 2) * 173456) % 10000),
b: Math.floor(((i + 7) * 373456) % 10000),
});
}
return rowData;
}
.number-cell {
text-align: right;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
<ag-grid-angular
[columnDefs]="columnDefs"
/* other grid options ... */ />
this.columnDefs = [
// simple currency formatter
{ field: 'price', valueFormatter: params => params.value == null ? '' : '$' + params.value },
// simple UPPER CASE formatter
{ field: 'code', valueFormatter: params => params.value?.toUpperCase() ?? '' }
]; Value Formatter Definition Copy Link
Below shows the column definition properties for value formatters.
A function or expression to format a value, should return a string. |
Please note the Value Formatter params won't always have data and node supplied, e.g. the params supplied to the Value Formatter in the Set Filter.
As a result favour formatter implementations that rely upon the 'value' argument instead, as this will lead to better reuse of your Value Formatters.
If using Cell Data Types, value formatters are set by default to handle the display of each of the different data types.
params.value may also be null or undefined, e.g. for group rows or rows whose data has not loaded. Value Formatters must handle this themselves. See TypeScript Generics for how typing TValue surfaces these cases at compile time.
If you want more than text formatting, e.g. you need Buttons in the Cell, then use a Cell Component.
Formatting for Export Copy Link
By default, the grid uses the value formatter when performing other grid operations that need values in string format.
This behaviour can be prevented by setting the column definition property useValueFormatterForExport = false (note this does not apply to rendering).
By default, values are formatted using the column's valueFormatter when exporting data from the grid.
This applies to CSV, Excel, and PDF export, as well as clipboard operations and the fill handle.
Set to false to prevent values from being formatted for these operations.
Regardless of this option, if custom handling is provided for the export operation, the value formatter will not be used. |
Using the value formatter for export applies to the following features:
Using a value formatter for export is normally used in conjunction with Using a Value Parser for Import, where a Value Parser is defined that does the reverse of the value formatter.
The following example demonstrates the default behaviour using the value formatter for export with each of the supported features mentioned above.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextEditorModule,
ValueFormatterParams,
ValueParserParams,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
PdfExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ExcelExportModule,
PdfExportModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[cellSelection]="cellSelection"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
headerName: "£A",
field: "a",
valueFormatter: currencyFormatter,
valueParser: currencyParser,
},
{
headerName: "£B",
field: "b",
valueFormatter: currencyFormatter,
valueParser: currencyParser,
},
];
defaultColDef: ColDef = {
cellDataType: false,
editable: true,
};
rowData: any[] | null = createRowData();
cellSelection: boolean | CellSelectionOptions = {
handle: {
mode: "fill",
},
};
}
function currencyFormatter(params: ValueFormatterParams) {
return params.value == null ? "" : "£" + params.value;
}
function currencyParser(params: ValueParserParams) {
let value = params.newValue;
if (value == null || value === "") {
return null;
}
value = String(value);
if (value.startsWith("£")) {
value = value.slice(1);
}
return parseFloat(value);
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(((i + 2) * 173456) % 10000),
b: Math.floor(((i + 7) * 373456) % 10000),
});
}
return rowData;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Note that if any of the following conditions are true, then useValueFormatterForExport is ignored for that feature and the value will be either the original value or that set in the custom handler:
- If
processCellForClipboardis provided when using copy/cut. - If
fillOperationis provided when using fill handle. - If
processCellForClipboardis provided when using copy range down. - If
processCellCallbackis provided when using CSV export. - If
processCellCallbackor Excel Data Types are provided when using Excel export. - If the underlying value is a number when using Excel export. To export formatted number values to Excel, please use the Excel Data Type feature.
- If
processCellCallbackis provided when using PDF export.

Use a Value Formatter to provide text formatting of values.
In the example below:
- Column
Raw Valuedisplays the value of theafield of the row data. - Column
Currency Amount (£)uses acurrencyFormatterto display the value as a currency. - Column
Bracketed Valueuses abracketsFormatterto display the value inside brackets.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
ValueFormatterParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([CellStyleModule, ClientSideRowModelModule]);
function bracketsFormatter(params: ValueFormatterParams) {
return "(" + params.value + ")";
}
function currencyFormatter(params: ValueFormatterParams) {
return "£" + formatNumber(params.value);
}
function formatNumber(number: number) {
return Math.floor(number).toLocaleString();
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(((i + 2) * 173456) % 10000),
b: Math.floor(((i + 7) * 373456) % 10000),
});
}
return rowData;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ headerName: "Raw Value", field: "a" },
{
headerName: "Currency Amount (£)",
field: "a",
valueFormatter: currencyFormatter,
},
{
headerName: "Bracketed Value",
field: "a",
valueFormatter: bracketsFormatter,
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
cellClass: "number-cell",
});
const rowData = ref<any[] | null>(createRowData());
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.number-cell {
text-align: right;
}
<ag-grid-vue
:columnDefs="columnDefs"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
// simple currency formatter
{ field: 'price', valueFormatter: params => params.value == null ? '' : '$' + params.value },
// simple UPPER CASE formatter
{ field: 'code', valueFormatter: params => params.value?.toUpperCase() ?? '' }
]; Value Formatter Definition Copy Link
Below shows the column definition properties for value formatters.
A function or expression to format a value, should return a string. |
Please note the Value Formatter params won't always have data and node supplied, e.g. the params supplied to the Value Formatter in the Set Filter.
As a result favour formatter implementations that rely upon the 'value' argument instead, as this will lead to better reuse of your Value Formatters.
If using Cell Data Types, value formatters are set by default to handle the display of each of the different data types.
params.value may also be null or undefined, e.g. for group rows or rows whose data has not loaded. Value Formatters must handle this themselves. See TypeScript Generics for how typing TValue surfaces these cases at compile time.
If you want more than text formatting, e.g. you need Buttons in the Cell, then use a Cell Component.
Formatting for Export Copy Link
By default, the grid uses the value formatter when performing other grid operations that need values in string format.
This behaviour can be prevented by setting the column definition property useValueFormatterForExport = false (note this does not apply to rendering).
By default, values are formatted using the column's valueFormatter when exporting data from the grid.
This applies to CSV, Excel, and PDF export, as well as clipboard operations and the fill handle.
Set to false to prevent values from being formatted for these operations.
Regardless of this option, if custom handling is provided for the export operation, the value formatter will not be used. |
Using the value formatter for export applies to the following features:
Using a value formatter for export is normally used in conjunction with Using a Value Parser for Import, where a Value Parser is defined that does the reverse of the value formatter.
The following example demonstrates the default behaviour using the value formatter for export with each of the supported features mentioned above.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSelectionOptions,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
TextEditorModule,
ValueFormatterParams,
ValueParserParams,
enableDevValidations,
} from "ag-grid-community";
import {
CellSelectionModule,
ClipboardModule,
ColumnMenuModule,
ContextMenuModule,
ExcelExportModule,
PdfExportModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
ClientSideRowModelModule,
ClipboardModule,
ExcelExportModule,
PdfExportModule,
ColumnMenuModule,
ContextMenuModule,
CellSelectionModule,
]);
function currencyFormatter(params: ValueFormatterParams) {
return params.value == null ? "" : "£" + params.value;
}
function currencyParser(params: ValueParserParams) {
let value = params.newValue;
if (value == null || value === "") {
return null;
}
value = String(value);
if (value.startsWith("£")) {
value = value.slice(1);
}
return parseFloat(value);
}
function createRowData() {
const rowData = [];
for (let i = 0; i < 100; i++) {
rowData.push({
a: Math.floor(((i + 2) * 173456) % 10000),
b: Math.floor(((i + 7) * 373456) % 10000),
});
}
return rowData;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:cellSelection="cellSelection"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{
headerName: "£A",
field: "a",
valueFormatter: currencyFormatter,
valueParser: currencyParser,
},
{
headerName: "£B",
field: "b",
valueFormatter: currencyFormatter,
valueParser: currencyParser,
},
]);
const defaultColDef = ref<ColDef>({
cellDataType: false,
editable: true,
});
const rowData = ref<any[] | null>(createRowData());
const cellSelection = ref<boolean | CellSelectionOptions>({
handle: {
mode: "fill",
},
});
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
cellSelection,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Note that if any of the following conditions are true, then useValueFormatterForExport is ignored for that feature and the value will be either the original value or that set in the custom handler:
- If
processCellForClipboardis provided when using copy/cut. - If
fillOperationis provided when using fill handle. - If
processCellForClipboardis provided when using copy range down. - If
processCellCallbackis provided when using CSV export. - If
processCellCallbackor Excel Data Types are provided when using Excel export. - If the underlying value is a number when using Excel export. To export formatted number values to Excel, please use the Excel Data Type feature.
- If
processCellCallbackis provided when using PDF export.